#ifndef __SYNCHPERIODIC_H__
#define __SYNCHPERIODIC_H__

#include <time.h>
#include <pthread.h>

class PeriodicBarrier {
 public:
  // constructor, initialize the object
  PeriodicBarrier(int n);

  // called by the threads for initial synch,
  // returns the same arrival time for all threads
  void wait(struct timespec *a);

  // called by the manager thread
  void start();

 private:
  struct timespec arrival;
  
  int nthreads;
  int blocked;

  pthread_mutex_t m;
  pthread_cond_t c_threads;
  pthread_cond_t c_manager;
};

#endif
